import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportElements.ReportCell;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ICellScript;
import quadbase.reportdesigner.util.IFormat;

public class CellScript extends Applet {

	static final long serialVersionUID = 1;

	public static void main(String[] args) {
		try {
			CellScript report = new CellScript();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", report.doCellScript(frame));
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public void init() {
		setLayout(new BorderLayout());
		add("Center", doCellScript(this));
	}

	Component doCellScript(Object parent) {

		// Do not use EspressManager
		QbReport.setEspressManagerUsed(false);

		// Open the template with backup data
		QbReport report = new QbReport(parent, // container 
				"CellScript.rpt", // template
				false, false, false, true);

		// Apply script
		ICellScript script = new zeroDataScript();
		report.getTable().getColumn(1).setCellScript(script);
		report.getTable().getColumn(2).setCellScript(script);

		// Show report in Viewer
		return (new Viewer().getComponent(report));
	}

	public class zeroDataScript implements ICellScript {

		static final long serialVersionUID = 1;

		/** Format the cells according to the specified parameters */
		public ReportCell formatCell(int rowIndex, ReportCell cell, Object originalData,
				IFormat dataFormat) throws Exception {

			if (originalData instanceof Double) {
				if (((Double) originalData).doubleValue() < 0) {
					cell.setFontColor(java.awt.Color.red);
				}
			}

			return cell;
		}
	}
}
